import 'iconfont_model.dart';

/// config
class IconfontConfig {
  /// pubspec.yaml 路径
  static String yamlPath = 'pubspec.yaml';

  /// 保存 pubspec.yaml 路径
  static String saveYamlPath = "pubspec.yaml.g";

  /// 读取路径
  static String readPath = 'assets/fonts/';

  /// 保存路径
  static String writePath = 'lib/icons/';

  /// 生成Iconfont文件
  static getIconFontTemp(IconFontModel iconFontModel, String className) {
    String itemContents = "";
    for (IconFontModelGlyphs glyph in iconFontModel.glyphs) {
      String preName = iconFontModel.cssPrefixText ?? "";
      String iconName = glyph.fontClass;

      itemContents +=
          """  static const IconData ${formatName("$preName$iconName")}= IconData(0x${glyph.unicode}, fontFamily: _family); //  ${glyph.name}
""";
    }

    String contents = '''
//  This file is automatically generated. DO NOT EDIT, all your changes would be lost.
//  https://pub.dartlang.org/packages/iconfont

import 'package:flutter/material.dart' show IconData;

class $className {
  static const String _family = '${iconFontModel.fontFamily}';
  $className._();
  
$itemContents
}
''';

    return contents;
  }

  /// 格式化
  static formatName(String str) {
    return str
        .replaceAll('-', '_')
        .split("_")
        .map((e) => e.isNotEmpty ? _capitalize(e) : "")
        .join("");
  }

  /// 首字母大写
  static String _capitalize(String str) {
    return "${str[0].toUpperCase()}${str.substring(1)}";
  }
}
